//
//  PhidgetAccelerometerPatch.h
//  PhidgetAccelerometerPatch
//
//  Created by KIMURA Hiroaki on 06/08/14.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "QCPatch.h"
#include <Phidget20/phidget20.h>

#import "PhidgetInfo.h"
#import "AccelInfo.h"

@class PhidgetAccelerometerPatchUI, PhidgetAccelerometerManager;

@interface PhidgetAccelerometerPatch : QCPatch {
	QCNumberPort* outputAccX;
	QCNumberPort* outputAccY;
	
	double xval, yval;
	double xaxis[7], yaxis[7];
	int serialNum;

	PhidgetAccelerometerManager* manager;
}



+ (int)executionMode;
+ (BOOL)allowsSubpatches;
- (id)initWithIdentifier:(id)fp8;
- (id)setup:(id)fp8;
- (BOOL)execute:(id)fp8 time:(double)fp12 arguments:(id)fp20;

- (void)setPhidgetHandle:(int)_serialNum;
- (long)serialNumber;
- (void)pollAccel:(id)sender;

@end

@interface PhidgetAccelerometerPatch (QCInspector)
+ (Class)inspectorClassWithIdentifier:(id)fp8;
@end