//
//  PhidgetAccelerometerPatch.m
//  PhidgetAccelerometerPatch
//
//  Created by KIMURA Hiroaki on 06/08/14.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import "PhidgetAccelerometerPatch.h"
#import "PhidgetAccelerometerManager.h"

@implementation PhidgetAccelerometerPatch

static NSMutableDictionary* handleDictionary;




+ (int)executionMode
{
	// I have found the following execution modes:
	//  1 - Renderer, Environment - pink title bar
	//  2 - Source, Tool, Controller - blue title bar
	//  3 - Numeric, Modifier, Generator - green title bar
	return 2;
}

+ (BOOL)allowsSubpatches
{
	// If your patch is a parent patch, like 3D Transformation,
	// you will allow subpatches, otherwise FALSE.
	return FALSE;
}

- (id)initWithIdentifier:(id)fp8
{
	[super initWithIdentifier:fp8];

	manager = [PhidgetAccelerometerManager phidgetAccelerometerManager];
	
	return self;
}

- (void)dealloc
{
	[super dealloc];
}

- (id)setup:(id)fp8
{
	return fp8;
}



- (BOOL)execute:(id)fp8 time:(double)fp12 arguments:(id)fp20
{
	[outputAccX setDoubleValue:xval];
	
	[outputAccY setDoubleValue:yval];
	
	return YES;
}

- (void)setPhidgetHandle:(int)_serialNum{
	

	if (serialNum == _serialNum){
		return;
	}
	
	[[NSNotificationCenter defaultCenter] removeObserver:self name:[NSString stringWithFormat:@"accel%d", serialNum] object:nil];
	
	
	serialNum = _serialNum;
	
	[[NSNotificationCenter defaultCenter] addObserver:self
											 selector:@selector(gotAccelChange:)
												 name:[NSString stringWithFormat:@"accel%d", serialNum] object:nil];
	
	NSNumber* num = [[manager handles] objectForKey:[NSString stringWithFormat:@"%d", serialNum]];
    
}


- (long)serialNumber{
	return serialNum;
}


////////////////////////Phidgets///////////////////////////////

- (void)gotAccelChange:(NSNotification *)notification
{
	int i=0;
	double out = 0;
	
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	AccelInfo* accelInfo = [notification object];
	
	if([accelInfo getIndex] == 0) {
		xaxis[6] = [accelInfo getVal];
		for(i=0;i<6;i++) {
			xaxis[i] = xaxis[i+1];
			out = out + xaxis[i];
		}
		xval = out/6.0;
	}
	else {
		yaxis[6] = [accelInfo getVal];
		for(i=0;i<6;i++) {
			yaxis[i] = yaxis[i+1];
			out = out + yaxis[i];
		}
		yval = out/6.0;
	}
	
	
	[pool release];
}


+ (Class)inspectorClassWithIdentifier:(id)fp8{

	return [PhidgetAccelerometerPatchUI class];
}


@end
