//
//  PhidgetAccelerometerPatchUI.m
//  PhidgetAccelerometerPatch
//
//  Created by KIMURA Hiroaki on 06/08/14.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import "PhidgetAccelerometerPatchUI.h"
#import "PhidgetAccelerometerPatch.h"
#import "PhidgetAccelerometerManager.h"


@implementation PhidgetAccelerometerPatchUI


+ (id)viewNibName{
	//NSLog(@"viewNibName is invoked.");
	return @"PhidgetAccelerometerUI.nib";
}


- (IBAction)choose:(id)sender{
	PhidgetAccelerometerManager* manager = [PhidgetAccelerometerManager phidgetAccelerometerManager];

	NSString* key = [sender titleOfSelectedItem];
	
	if ([key isEqualToString:@"not selected"]){
		return;
	}
	
	[[self patch] setPhidgetHandle:atol([key cString])];
	
	long version;
	int numMotors;
	
	
	NSDictionary* handleDictionary = [manager handles];
	NSNumber* num = [handleDictionary objectForKey:key];
	long accel = [num longValue];
	CPhidget_getDeviceVersion(accel, &version);
	CPhidgetAccelerometer_getNumAxis(accel,&numMotors);
	[serialNumberField setIntValue:atol([key cString])];
	[versionField setIntValue:version];
	[numOfAxisField setIntValue:numMotors];
	
}

- (void)dealloc{
	
	
	[super dealloc];
}


- (id)init{
	[super init];
	[button removeAllItems];
	[button addItemWithTitle:@"not selected"];
	
	[[NSNotificationCenter defaultCenter] addObserver:self
											 selector:@selector(update:)
												 name:@"updateUI" object:nil];
	
	return self;
}

- (void)update:(NSNotification *)notification{
	[button removeAllItems];
	[button addItemWithTitle:@"not selected"];
	[serialNumberField setStringValue:@""];
	[versionField setStringValue:@""];
	[numOfAxisField setStringValue:@""];
	
	
	PhidgetAccelerometerPatch* pap = (PhidgetAccelerometerPatch*)_patch;
	PhidgetAccelerometerManager* manager = [PhidgetAccelerometerManager phidgetAccelerometerManager];
	NSDictionary* handleDictionary = [manager handles];
	
	NSEnumerator* enumerator = [handleDictionary keyEnumerator];
	NSString* key;
	
	while (key = [enumerator nextObject]){
		[button addItemWithTitle:key];
		
		long tmpserial = atol([key cString]);
		long serial = [pap serialNumber];
		
		if (tmpserial == serial){
			[button selectItemWithTitle:key];
			
			long version;
			int numMotors;
			
			NSNumber* num = [handleDictionary objectForKey:key];
			long accel = [num longValue];
			CPhidget_getDeviceVersion(accel, &version);
			CPhidgetAccelerometer_getNumAxis(accel,&numMotors);
			[serialNumberField setIntValue:serial];
			[versionField setIntValue:version];
			[numOfAxisField setIntValue:numMotors];
			
		}
	}
}


- (void) setupViewForPatch:(id)fp8{
	[super setupViewForPatch:fp8];
	_patch = fp8;

	[self update:nil];
	
}

- (void)updateParameters:(id)fp8{
	NSLog(@"updateParameters: %@", [fp8 className]);
}
- (void)updateSize:(id)fp8{
	NSLog(@"updateSize: %@", [fp8 className]);
}

- (void)updateUI:(id)fp8{
	NSLog(@"updateUI: %@", [fp8 className]);
}

@end
